package com.gic.haoban.manage.service.service.out.impl.chat;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.api.base.commons.BasePageInfo;
import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.PageHelperUtils;
import com.gic.haoban.manage.api.dto.chat.GroupChatHmDTO;
import com.gic.haoban.manage.api.dto.hm.HmLinkChatDTO;
import com.gic.haoban.manage.api.dto.qdto.chat.ChatHmSearchQDTO;
import com.gic.haoban.manage.api.dto.qdto.hm.HmLinkChatQDTO;
import com.gic.haoban.manage.api.service.chat.GroupChatHmApiService;
import com.gic.haoban.manage.service.pojo.bo.chat.GroupChatHmBO;
import com.gic.haoban.manage.service.service.chat.GroupChatHmService;
import com.gic.haoban.manage.service.service.hm.HmLinkChatService;

/**
 * 
* @ClassName: GroupChatHmApiService
* @Description: 群活码
* @author xugh
* @date 2022年12月1日 下午7:44:51
*
 */
@Service("groupChatHmApiService")
public class GroupChatHmApiServiceImpl implements GroupChatHmApiService {

    @Autowired
    private GroupChatHmService groupChatHmService;
    @Autowired
    private HmLinkChatService hmLinkChatService;

    @Override
    public ServiceResponse<Page<GroupChatHmDTO>> listPage(ChatHmSearchQDTO qdto, BasePageInfo basePageInfo) {
        Page<GroupChatHmBO> page = this.groupChatHmService.listPage(qdto, basePageInfo);
        Page<GroupChatHmDTO> resultPage = PageHelperUtils.changePageToCurrentPage(page, GroupChatHmDTO.class);
        return ServiceResponse.success(resultPage);
    }

    @Override
    public ServiceResponse<GroupChatHmDTO> detail(Long chatHmId) {
        GroupChatHmBO bo = this.groupChatHmService.getById(chatHmId);
        GroupChatHmDTO dto = EntityUtil.changeEntityByJSON(GroupChatHmDTO.class, bo);
        return ServiceResponse.success(dto);
    }

    @Override
    public ServiceResponse<GroupChatHmDTO> save(GroupChatHmDTO dto) {
        this.groupChatHmService.saveHm(dto);
        return ServiceResponse.success(dto);
    }

    @Override
    public ServiceResponse<Page<HmLinkChatDTO>> listPageChatLink(String wxEnterpriseId, Long chatHmId,
            BasePageInfo basePageInfo) {
        HmLinkChatQDTO qdto = new HmLinkChatQDTO();
        qdto.setWxEnterpriseId(wxEnterpriseId);
        qdto.setChatHmId(chatHmId);
        Page<HmLinkChatDTO> page = this.hmLinkChatService.listPage(qdto, basePageInfo);
        return ServiceResponse.success(page);
    }

}
